; Missing Persons Anagram - 3-Apr-2025 by KPK
; Assembler: Acme

!addr tmp = $02    ; temporary variable
!addr src = $fb    ; index of source (first screen row)
!addr dst = $fc    ; index of destination (second screen row) 

*=$801
!word line2:!pet 10,0,$8f,$20,"anagram: 3-apr-2025 by kpk",0
line2:!word prgend:!byte 20,0,$9e,$20:!for i,3,0 {!pet '0'+start%10^(i+1)/10^i}
prgend: !fill 3,0

; ------------------------------------------------------------------------------

start
  lda #$0b         ; dark gray
  sta $d020        ; border color
  lda #$00         ; black
  sta $d021        ; background color
  lda #$05         ; green
  sta $286         ; cursor color

; ------------------------------------------------------------------------------

main
  lda #$93         ; clear screen
  jsr $ffd2
  lda #<anagram
  ldy #>anagram
  jsr $ab1e        ; print encoded anagram
  lda #$00         ; index of source (first screen row)
  sta src
  lda #$28         ; index of destination (second screen row)
  sta dst
  jsr init_sprites ; initialize sprites
  jsr time_delay   ; one-second delay

loop
  ldy src          ; index of source (first screen row)
  lda offsets,y    ; offset to character to be moved
  cmp #-1          ; denotes a space
  bne +
  inc src          ; skip spaces
  inc dst
  bne loop
+ tax
  lda $400,x       ; get character from first screen row at offset
  pha
  lda #$20         ; erase the character to be moved
  sta $400,x
  ldx dst          ; index of destination (second screen row) 
  pla
  jsr sprite_char  ; set sprite 0 to the character in a-reg and move it
  sta $400,x       ; set character in target location
  inc src          ; prepare to read next character from first screen row
  inc dst          ; prepare to write next character to second screen row
  jsr $ffe4        ; check for keypress
  bne done         ; if key is pressed, exit program
  lda src
  cmp #$0f         ; check whether all characters have been moved
  bne loop         ; if not, get next character
  lda #$06         ; if so, turn off sprite 0
  sta $d015
  jsr time_delay   ; one-second delay to show decoded anagram
  beq main         ; repeat animation
done
  lda #$00         ; turn off all sprites
  sta $d015
  rts              ; exit program

; ------------------------------------------------------------------------------

time_delay         ; one-second delay
  lda $a2
  adc #$3c
- cmp $a2
  bne -
  rts

; ------------------------------------------------------------------------------

init_sprites
  lda #$05         ; green
  sta $d027        ; color sprite 0
  lda #$01         ; white
  sta $d028        ; color sprite 1
  lda #$02         ; red
  sta $d029        ; color sprite 2
  lda #$48
  sta $d002        ; x location sprite 1
  sta $d003        ; y location sprite 1
  sta $d004        ; x location sprite 2
  sta $d005        ; y location sprite 2
  ldx #$0d
  stx $7f8         ; data pointer sprite 0
  inx
  stx $7f9         ; data pointer sprite 1
  inx
  stx $7fa         ; data pointer sprite 2
  lda #$00         ; clear sprite 0 data
  tay
- sta $340,y
  iny
  cpy #$80
  bne -
  ldy #$3e         ; copy sprite 1 data
- lda dale_sprite,y
  sta $380,y
  dey
  bpl -
  ldy #$0c         ; copy sprite 2 data
- lda lip_stick,y
  sta $3ec,y
  dey
  bpl -
  lda #$07         ; enable sprites 0, 1 & 2
  sta $d015
  rts

; ------------------------------------------------------------------------------

sprite_char
  sei              ; disable interrupts
  stx tmp          ; preserve x-reg
  pha              ; preserve a-reg
  asl              ; multiply by 8 to convert character code to char bitmap offset
  asl
  asl
  tax
  lda #$33         ; switch in character rom
  sta $01
  ldy #$00         ; copy character bitmap to sprite
- lda $d000,x
  sta $340,y
  inx
  iny
  iny
  iny
  cpy #$15
  bne -
  lda #$37         ; switch out character rom
  sta $01
  pla              ; restore a-reg
  ldx tmp          ; restore x-reg
  cli              ; enable interrupts
  jsr move_sprite  ; move character from first screen row to second via sprite
  rts

; ------------------------------------------------------------------------------

move_sprite        ; move character from first screen row to second via sprite
  pha              ; preserve a-reg
  txa
  pha              ; preserve x-reg
  lda #$32
  sta $d001        ; set sprite y-loc to first screen row
  ldx src
  lda offsets,x
  asl
  asl
  asl
  adc #$18
  sta $d000        ; set sprite x-loc to character location on first screen row
-- lda $a2         ; short delay for character vertical "drop" animation
  adc #$02
- cmp $a2
  bne -
  inc $d001        ; move character down from first screen row to second
  lda $d001
  cmp #$3a
  bne --
  lda src          ; get target x-loc for character sprite
  asl
  asl
  asl
  adc #$18
  tax
-- lda $a2         ; short delay for character horizontal "slide" animation
- cmp $a2
  beq -
  cpx $d000        ; when sprite is at the target location...
  beq ms_done      ; ...we are done for this character
  bcc +
  inc $d000        ;...otherwise slide right
  bne --
+ dec $d000        ;...or slide left
  bne --
ms_done
  pla              ; restore x-reg
  tax
  pla              ; restore a-reg
  rts

; ------------------------------------------------------------------------------

anagram !pet "spring session m",13,13,0
offsets !byte 15,3,0,7,11,4,5,-1,1,8,2,9,12,13,10
dale_sprite
!byte %########,%########,%########
!byte %########,%########,%########
!byte %########,%########,%########
!byte %########,%########,%#....###
!byte %########,%########,%......#.
!byte %########,%########,%......#.
!byte %#######.,%....####,%.....##.
!byte %######..,%....####,%#######.
!byte %######..,%...#####,%#######.
!byte %########,%########,%######..
!byte %########,%########,%######..
!byte %########,%########,%#.####..
!byte %########,%######.#,%#.####..
!byte %########,%########,%######..
!byte %########,%########,%##..#...
!byte %.#######,%#######.,%....#...
!byte %..#..###,%######..,%....#...
!byte %......##,%#####...,%##..#...
!byte %.......#,%#######.,%..###...
!byte %........,%########,%#####...
!byte %........,%.#######,%####....
lip_stick
!hex 300001f00003f00007300001c0